﻿using Syncfusion.Pdf;
using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Drawing;
using Syncfusion.Pdf.Graphics;
using Xamarin.Forms;
using Syncfusion.Pdf.Grid;

namespace SimpleSample
{
    public class ChartSample : ContentPage
    {
		private SfChart chart;
        public ChartSample()
        {
            var stack = new StackLayout();
            var button = new Button();
            button.Clicked += button_Clicked;
            button.Text = "Export as PDF";

			chart = new SfChart
            {
                VerticalOptions = LayoutOptions.FillAndExpand,                
                PrimaryAxis = new CategoryAxis { LabelPlacement = LabelPlacement.BetweenTicks },
                SecondaryAxis = new NumericalAxis()
            };

            chart.Series.Add(new ColumnSeries
            {
                DataMarker = new ChartDataMarker(),
                ItemsSource = GetDataPoints(),
                DataMarkerPosition = DataMarkerPosition.Center,
            });

            stack.Children.Add(button);            
            Content = stack;
        }

        void button_Clicked(object sender, EventArgs e)
        {
            var document = new PdfDocument();
            chart.WidthRequest = document.PageSettings.Width;
            chart.HeightRequest = document.PageSettings.Height;
          
            
            // adding text to the PDF
            PdfPage page = document.Pages.Add();

           PdfStandardFont font = new PdfStandardFont(PdfFontFamily.Helvetica, 15);

            page.Graphics.DrawString("Grid table is shown below", font, PdfBrushes.Black, new PointF(20,20));




            //Create a PdfGrid.

            PdfGrid pdfGrid = new PdfGrid();

            //Add values to list

            List<object> data = new List<object>();

            Object row1 = new { ID = "E01", Name = "Clay" };

            Object row2 = new { ID = "E02", Name = "Thomas" };

            data.Add(row1);

            data.Add(row2);

            //Add list to IEnumerable

            IEnumerable<object> dataTable = data;

            //Assign data source.

            pdfGrid.DataSource = dataTable;

            //Draw grid to the page of PDF document.

            pdfGrid.Draw(page, new Syncfusion.Drawing.PointF(20, 40));



            var stream = chart.GetStream();
            DependencyService.Get<IChartDependencyService>().SaveAsPDF("Sf.pdf", stream, chart, document);
       }       

        private static List<ChartDataPoint> GetDataPoints()
        {
            return new List<ChartDataPoint>
            {
                new ChartDataPoint("A", 45),
                new ChartDataPoint("B", 54),
                new ChartDataPoint("C", 65),
                new ChartDataPoint("D", 23),
                new ChartDataPoint("E", 55),
            };
        }
    }
}
